Package net.sf.saxon.functions.registry

## Class ConstructorFunctionLibrary

- java.lang.Object
- - net.sf.saxon.functions.registry.ConstructorFunctionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class ConstructorFunctionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  The ConstructorFunctionLibrary represents the collection of constructor functions for atomic types. These are provided for the built-in types such as xs:integer and xs:date, and also for user-defined atomic types.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ConstructorFunctionLibrary​(Configuration config)` | Create a SystemFunctionLibrary

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Expression` | `bind​(SymbolicName.F functionName, Expression[] arguments, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind a static function call, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### ConstructorFunctionLibrary

          public ConstructorFunctionLibrary​(Configuration config)

      Create a SystemFunctionLibrary
      Parameters:
        `config` - the Configuration

  - ### Method Detail

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Description copied from interface: `FunctionLibrary`
      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called, together with its arity. For legacy reasons, the arity may be set to -1 to mean any arity will do
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          public Expression bind​(SymbolicName.F functionName,
                                 Expression[] arguments,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind a static function call, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `functionName` - The QName of the function
        `arguments` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm.
        `env` - The static context
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the constructor function to be called, if one is found; null if no constructor function was found matching the required name and arity.

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.